package gossip;

%%

%class Scanner
%function getToken
%type Token
%yylexthrow Exception
%line
%column

%state STRING

digit = [0-9]
letter = [a-zA-Z_]
alpha = {letter} | {digit}
space = [ \n\r\t]
// TODO: comentários

%%

// TODO: palavras chave

{letter}{alpha}*	     { return new Token(Token.ID, yytext(), yyline, yycolumn); }

// TODO: numerais

"<="   { return new Token(Token.LEQ, yyline, yycolumn); }
"=="   { return new Token(Token.EQ, yyline, yycolumn); }
"&&"   { return new Token(Token.AND, yyline, yycolumn); }
"||"   { return new Token(Token.OR, yyline, yycolumn); }

"+" | "-" | "*" | "/" | "=" | "<" | "(" | ")" | ";" | "!" | 
   "{" | "}" | "[" | "]" | "," | "." { return new Token((int)yytext().charAt(0), yyline, yycolumn); }

{space}    { }

{comment}    { }

// TODO: literais string

.  { throw new Exception("scanner error at line " + yyline + " column " + yycolumn + ", token: " + yytext()); }
